module Config where

import Types

-- | prepend image dir for given image basename.
imageFile :: String -> String
imageFile basename = "/data/qvm/images/" ++ basename

-- | return domain's data dir.
domainDir :: String -> String
domainDir dname = "/data/qvm/instances/" ++ dname

-- | return full path to VM's root disk file
diskFile :: QvmDomain -> String -> String
diskFile d _suffix = domainDir (name d) ++ "/disk"

-- | return full path to domain file
domainFile :: QvmDomain -> String
domainFile d = domainDir (name d) ++ "/domain.xml"

metadataDir :: QvmDomain -> String
metadataDir d = domainDir (name d) ++ "/meta"

metadataFile :: QvmDomain -> String
metadataFile d = metadataDir d ++ "/meta-data"

userdataFile :: QvmDomain -> String
userdataFile d = metadataDir d ++ "/user-data"

-- | return full path to metadata iso file
metadataISOFile :: QvmDomain -> String
metadataISOFile d = domainDir (name d) ++ "/meta.iso"
