module DownloadFile where

import Data.Conduit.Binary (sinkFile)
import Network.HTTP.Conduit
import qualified Data.Conduit as C
import Control.Monad.Trans.Resource (runResourceT)

-- | Download resource at url to localfile. Overwrite existing file
-- automatically. This function supports downloading very large disk image.
downloadFile :: String -> String -> IO (Either String String)
downloadFile url localfile = do
  request <- parseUrl url
  manager <- newManager tlsManagerSettings
  runResourceT $ do
    response <- http request manager
    responseBody response C.$$+- sinkFile localfile
  return $ Right localfile
