{-# LANGUAGE QuasiQuotes, OverloadedStrings #-}
{-# LANGUAGE TemplateHaskell #-}

module RenderFile (stFile) where

import Language.Haskell.TH.Quote (QuasiQuoter (..))
import Language.Haskell.TH.Syntax
import Data.Text.Lazy.Builder (Builder, fromText, toLazyText, fromLazyText)
import Data.Text.Lazy.Builder.Int (decimal)
import qualified Data.Text as TS
import qualified Data.Text.Lazy as TL
import Text.Shakespeare
import Data.Int (Int32, Int64)

import Text.Shakespeare.Text (ToText(..))

settings :: Q ShakespeareSettings
settings = do
  toTExp <- [|toText|]
  wrapExp <- [|id|]
  unWrapExp <- [|id|]
  return $ defaultShakespeareSettings { toBuilder = toTExp
  , wrap = wrapExp
  , unwrap = unWrapExp
  }

stFile :: QuasiQuoter
stFile =
  QuasiQuoter {quoteExp =
                 \path ->
                   do rs <- settings
                      render <- [|TL.toStrict . toLazyText|]
                      rendered <-
                        shakespeareFile rs {justVarInterpolation = True} path
                      return (render `AppE` rendered)}
